﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Competition
{
    public class AIBonusDef
    {
        public Poklad Poklad;
        public int Steps;

    }
    public class AIPole
    {
        public int X;
        public int Y;
        public List<AIBonusDef> Definitions = new List<AIBonusDef>();
    }
    public class AIGame
    {
        public Poklad locked;

        public Game g;
        public List<AIPole> Pole = new List<AIPole>();
        public void GetDefinitions()
        {

            Pole.Clear();
            for (int x = 0; x < 10; x++)
            {
                for (int y = 0; y < 10; y++)
                {
                    Pole.Add(new AIPole() { X = x, Y = y });
                }
            }
            foreach (var pokl in g.Plan.OfType<Poklad>())
            {
                enumerated.Clear();

                EnumeratePole(pokl.X, pokl.Y, pokl, 1);
            }
        }
        public void EnumeratePole(int startX, int startY, Poklad pokl, int currSteps = 1)
        {
            //SaveDef(Pole.SingleOrDefault(t => t.X == startX && t.Y == startY), pokl, 0);
            enumerated.Add(new Tuple<int,int>(startX,startY));
            var x=startX-1;
            var y=startY;
            if (ValidPole(x, y))
            {
                enumerated.Add(new Tuple<int,int>(x, y));
                SaveDef(Pole.SingleOrDefault(t => t.X == x && t.Y == y), pokl, currSteps);
                EnumeratePole(x, y,pokl,currSteps+1);
            }
            x = startX + 1;
            y = startY;
            if (ValidPole(x, y))
            {
                enumerated.Add(new Tuple<int, int>(x, y));
                SaveDef(Pole.SingleOrDefault(t => t.X == x && t.Y == y), pokl, currSteps);
                EnumeratePole(x, y, pokl, currSteps + 1);
            }
            x = startX;
            y = startY - 1;
            if (ValidPole(x, y))
            {
                enumerated.Add(new Tuple<int, int>(x, y));
                SaveDef(Pole.SingleOrDefault(t => t.X == x && t.Y == y), pokl, currSteps);
                EnumeratePole(x, y, pokl, currSteps + 1);
            }
            x = startX;
            y = startY + 1;
            if (ValidPole(x, y))
            {
                enumerated.Add(new Tuple<int, int>(x, y));
                SaveDef(Pole.SingleOrDefault(t => t.X == x && t.Y == y), pokl, currSteps);
                EnumeratePole(x, y, pokl, currSteps + 1);
            }
        }
        List<Tuple<int, int>> enumerated = new List<Tuple<int, int>>();
        private bool ValidPole(int x, int y, bool suppEnumC=false)
        {
            
            if (x < 0 || y < 0 || x >= 10 || y >= 10)
                return false;
            if (!suppEnumC&&enumerated.Any(j => j.Item1 == x && j.Item2 == y))
                return false;
            var pole=g.Plan.Except(g.Plan.OfType<Hrac>()).SingleOrDefault(i => i.X == x&& i.Y == y);
            if(pole is Zed || (!suppEnumC&&pole is Poklad)|| (pole is Zakladna&&!((Zakladna)pole).Mine)|| (pole is Hrac&&!((Hrac)pole).Mine))
                return false;
            return true;
        }
        public void SaveDef(AIPole def1,Poklad pokl,int currSteps)
        {
            var pdef = def1.Definitions.SingleOrDefault(x => x.Poklad == pokl);
            if (pdef != null)
            {
                if (pdef.Steps > currSteps)
                {
                    pdef.Steps = currSteps;
                }
            }
            else
            {
                def1.Definitions.Add(new AIBonusDef() { Poklad = pokl, Steps = currSteps });
            }
        }
        public async Task Play()
        {
            while (true)
            {
                try
                {
                    GetDefinitions();
                    LockATreasure();
                    var hrac=g.GetHrac();
                    while (hrac.X != locked.X && hrac.Y != locked.Y)
                    {
                        await g.Tah(GetNextStepTowardsTreasure());
                    }
                    foreach (var step in GetPathToHomeFromTreasure().Reverse())
                    {
                        Game.TahOpt stepr = Game.TahOpt.N;
                        switch (step)
                        {
                            case Game.TahOpt.D:
                                stepr = Game.TahOpt.N;
                                break;
                            case Game.TahOpt.N:
                                stepr = Game.TahOpt.D;
                                break;
                            case Game.TahOpt.L:
                                stepr = Game.TahOpt.P;
                                break;
                            case Game.TahOpt.P:
                                stepr = Game.TahOpt.L;
                                break;
                        }
                        await g.Tah(stepr);
                    }
                    if (g.tahu <= 0)
                        MessageBox.Show("Hra skon4ila");
                }
                catch
                {
                    break;
                }
            }
            MessageBox.Show("hra skončila");
        }

        public void LockATreasure()
        {
            var hrac=g.GetHrac();
            var bas=g.Plan.OfType<Zakladna>().SingleOrDefault(x=>x.Mine);
            var deffp = Pole.SingleOrDefault(x => x.X == hrac.X && x.Y == hrac.Y).Definitions;
             var deffb = Pole.SingleOrDefault(x => x.X == bas.X && x.Y == bas.Y).Definitions;
             List<AIBonusDef> totalDef = new List<AIBonusDef>();
             foreach (var inter in deffb)
             {
                 var fff=deffp.SingleOrDefault(x=>x.Poklad==inter.Poklad);
                 if (fff != null)
                     totalDef.Add(new AIBonusDef() { Poklad = inter.Poklad, Steps = inter.Steps + fff.Steps });
             }
             var rtes = totalDef.Where(x => x.Steps <= g.tahu).Select(x => new { Rank = x.Steps!=0?(x.Poklad.Hodnota / x.Steps):0, Val = x }).OrderByDescending(x => x.Rank).FirstOrDefault();
             if (rtes == null)
             {
                 MessageBox.Show("Cannot find a treasure");
                 throw new Exception();
             }
            locked = rtes.Val.Poklad;
        }
        public Game.TahOpt GetNextStepTowardsTreasure()
        {
            var Player = g.GetHrac();
            var enn=EnumeratePole(Player.X, Player.Y);
            var rrr=enn.Where(x => locked.X == x.X && locked.Y == x.Y);
            AIPole finP;
            if (rrr.Count() > 0)
            {
                finP = rrr.FirstOrDefault();
            }
            else
            {
                var nstep = enn.Select(x => x.Definitions.SingleOrDefault(y => y.Poklad == locked)).OrderBy(x => x.Steps).FirstOrDefault();
                finP = enn.FirstOrDefault(x => x.Definitions.SingleOrDefault(y => y.Poklad == locked).Steps == nstep.Steps);
            }
            if (finP.Y > Player.Y)
                return Game.TahOpt.D;
            if (finP.Y < Player.Y)
                return Game.TahOpt.N;
            if (finP.X > Player.X)
                return Game.TahOpt.P;
            if (finP.X< Player.X)
                return Game.TahOpt.L;
            throw new Exception();
        }
        public IEnumerable<Game.TahOpt> GetPathToHomeFromTreasure()
        {
            var bas = g.Plan.OfType<Zakladna>().SingleOrDefault(x => x.Mine);
            var deffb = Pole.SingleOrDefault(x => x.X == bas.X && x.Y == bas.Y).Definitions;

        

            int lastX = bas.X;
            int lastY = bas.Y;

            while (true)
            {
                var enn = EnumeratePole(lastX, lastY);
                var rrr = enn.Where(x => locked.X == x.X && locked.Y == x.Y);
                AIPole finP;
                if (rrr.Count() > 0)
                {
                    finP = rrr.FirstOrDefault();
                }
                else
                {
                    var nstep = enn.Select(x => x.Definitions.SingleOrDefault(y => y.Poklad == locked)).OrderBy(x => x.Steps).FirstOrDefault();
                    finP = enn.FirstOrDefault(x => x.Definitions.SingleOrDefault(y => y.Poklad == locked).Steps == nstep.Steps);
                }
                
                if (finP.Y > lastY)
                    yield return Game.TahOpt.D;
                if (finP.Y < lastY)
                    yield return Game.TahOpt.N;
                if (finP.X > lastX)
                    yield return Game.TahOpt.P;
                if (finP.X < lastX)
                    yield return Game.TahOpt.L;
                lastX = finP.X;
                lastY = finP.Y;
                if (rrr.Count() > 0)
                    yield break;
            }
        }

        public IEnumerable<AIPole> EnumeratePole(int startX, int startY)
        {
            var x = startX - 1;
            var y = startY;
            if (ValidPole(x, y,true))
            {
                yield return Pole.SingleOrDefault(i => i.X == x && i.Y == y);
            }
            x = startX + 1;
            y = startY;
            if (ValidPole(x, y, true))
            {
                yield return Pole.SingleOrDefault(i => i.X == x && i.Y == y);
            }
            x = startX;
            y = startY - 1;
            if (ValidPole(x, y, true))
            {
                yield return Pole.SingleOrDefault(i => i.X == x && i.Y == y);
            }
            x = startX;
            y = startY + 1;
            if (ValidPole(x, y, true))
            {
                yield return Pole.SingleOrDefault(i => i.X == x && i.Y == y);
            }
        }
    }
}
