﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace Competition
{
    public class Game
    {
        string baseUrl;
        public Game(string burl)
        {
            cli = new WebClient();
            baseUrl=burl;
        }
        WebClient cli;
        public List<Pole> Plan;
        string id;
        public int tahu;
        public int tahuCelkem;
        public async Task Start()
        {
            GameEnded = false;
            var str=await cli.DownloadStringTaskAsync(new Uri(baseUrl + "/start"));
            var lines = str.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
            id = lines[0].Trim();
            tahuCelkem=tahu = int.Parse(lines[1].Trim());
            Plan = new List<Pole>();
            Plan.Add(new Hrac() { Mine = true, Celkem = 0, Poklad = 0 });

            for (int i = 2; i < 12; i++)
            {
                for (int j = 0; j < 20; j += 2)
                {
                    string head=lines[i].Substring(j, 2);
                    switch (head)
                    {
                        case "++":
                            Plan.Add(new Zakladna() { Mine = true, X = j / 2, Y = i - 2 });
                            break;
                        case "--":
                            Plan.Add(new Zakladna() { Mine = false, X = j / 2, Y = i - 2 });
                            break;
                        case "..":
                            break;
                        case "XX":
                            Plan.Add(new Zed() { X = j / 2, Y = i - 2 });
                            break;

                        default:
                            Plan.Add(new Poklad() { Hodnota=int.Parse(head) , X = j / 2, Y = i - 2 });
                            break;
                    }
                }
            }
            var mp = lines[12].Split(' ');
            var hrac=GetHrac(false);
            hrac.X = int.Parse(mp[0])-1;
            hrac.Y = int.Parse(mp[1])-1;
            hrac.Poklad = int.Parse(mp[2]);
            hrac.Celkem = int.Parse(mp[3]);

            if (lines.Length == 14)
            {
                
                mp = lines[13].Split(' ');
                hrac = GetHrac(true);
                if(hrac==null)
                    Plan.Add(hrac = new Hrac() { Mine = false, Celkem = 0, Poklad = 0 });
                hrac.X = int.Parse(mp[0])-1;
                hrac.Y = int.Parse(mp[1])-1;
                hrac.Poklad = int.Parse(mp[2]);
                hrac.Celkem = int.Parse(mp[3]);
            }
            
        }
        public enum TahOpt
        {
            N,D,L,P
        }
        public Hrac GetHrac(bool opp=false)
        {
            return Plan.SingleOrDefault(x=>x is Hrac&&(x as Hrac).Mine==!opp) as Hrac;
        }
        public bool CanExcuteTah(TahOpt opt)
        {
            var player=GetHrac();
            int x = player.X; int y = player.Y;
            switch (opt)
            {
                case TahOpt.D:
                    y+=1;
                    break;
                case TahOpt.N:
                    y -= 1;
                    break;
                case TahOpt.P:
                    x += 1;
                    break;
                case TahOpt.L:
                    x -= 1;
                    break;
            }
            bool v= x >= 0 && x < 10 && y >= 0 && y < 10;
            var kk = Plan.SingleOrDefault(i => i.X == x && i.Y == y);
            return v && (kk == null || (kk is Zakladna && (kk as Zakladna).Mine) || (kk is Poklad));
        }
        public bool GameEnded = false;
        public string GameEndedText = "";
        public async Task<bool> Tah(TahOpt opt)
        {
            bool v = CanExcuteTah(opt);
            if (!v)
                return false;
            var str=await cli.DownloadStringTaskAsync(new Uri(baseUrl + "/tah?id="+this.id+"&pohyb="+opt.ToString()));
            var lines = str.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
            if (lines.Length < 10)
            {
                GameEnded = true;
                GameEndedText = str;
                return true;
            }
            //id = lines[0].Trim();
            tahu = int.Parse(lines[1].Trim());

            for (int i = 2; i < 12; i++)
            {
                for (int j = 0; j < 20; j += 2)
                {
                    string head=lines[i].Substring(j, 2);
                    switch (head)
                    {
                        case "++":
                            break;
                        case "--":
                            break;
                        case "..":
                            var sss=Plan.Where(x=>!(x is Hrac)).SingleOrDefault(x=> x.X == j / 2&& x.Y == i - 2);
                            if(sss!=null)
                            {
                                Plan.Remove(sss);
                            }

                            break;
                        case "XX":
                            break;
                    }
                }
            }
            var mp = lines[12].Split(' ');
            var hrac = GetHrac(false);
            hrac.X = int.Parse(mp[0])-1;
            hrac.Y = int.Parse(mp[1])-1;
            hrac.Poklad = int.Parse(mp[2]);
            hrac.Celkem = int.Parse(mp[3]);

            if (lines.Length == 14)
            {

                mp = lines[13].Split(' ');
                hrac = GetHrac(true);
                if (hrac == null)
                    Plan.Add(hrac = new Hrac() { Mine = false, Celkem = 0, Poklad = 0 });
                hrac.X = int.Parse(mp[0])-1;
                hrac.Y = int.Parse(mp[1])-1;
                hrac.Poklad = int.Parse(mp[2]);
                hrac.Celkem = int.Parse(mp[3]);
            }
            return true;
        }
    }
}
